<?php

/* * ********************************************************************
 * ProxmoxAddon product developed. (Aug 23, 2018)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

namespace ModulesGarden\Servers\ProxmoxVps\App\UI\Validators;

use ModulesGarden\ProxmoxAddon\App\Models\VmIpAddress;
use ModulesGarden\Servers\ProxmoxVps\Core\UI\Widget\Forms\Validators\BaseValidator;

/**
 * Description of NumberValidator
 *
 * @author Pawel Kopec <pawelk@modulesgardne.com>
 */
class IpAddressValidator extends BaseValidator
{
    protected $required = false;

    public function __construct($required = false)
    {
        $this->required = $required;
    }

    protected function validate($data, $additionalData = null)
    {

        if (!$this->required && empty($data))
        {
            return true;
        }
        if (!filter_var($data, FILTER_VALIDATE_IP))
        {
            $this->addValidationError('IP Address is not valid', false);
            return false;
        }
        if ($this->required && VmIpAddress::ofIp($data)->count())
        {
            $this->addValidationError('IP Address already exist', false);
            return false;
        }
        return true;
    }
}
